:: Turn off system messages
@echo off
:: Clear screen
cls;
:: Welcome message
echo.
echo ********************************************
echo * TerraPrint Installer for Windows 64-bits *
echo ********************************************
echo.
:: ====

set _CMAKE_GENERATOR="Visual Studio 12 2013 Win64"

:: Where is script file
set "ROOT_DIR=%CD%"
set "WORKSPACE=%CD%\..\.."
:: TerraLib Paths
set "TERRALIB_DEPENDENCIES_DIR=C:\MyDevel\terralib\3rdparty\release-5.3"
set "TERRALIB_DIR=%WORKSPACE%\terralib-install"

:: TerraPrint Paths
set "TERRAPRINT_CODEBASE_PATH=%WORKSPACE%\terraprint-codebase"
set "TERRAPRINT_BUILD_PATH=%WORKSPACE%\build-terraprint"
set "TERRAPRINT_INSTALL_PATH=%WORKSPACE%\terraprint-install"

:: Where is Dependencies
set "QMAKE_FILEPATH=C:\Qt5.4.1\5.4\msvc2013_64\bin"
set "VCVARS_FILEPATH=%PROGRAMFILES(x86)%\Microsoft Visual Studio 12.0\VC"
set "CMAKE_FILEPATH=%PROGRAMFILES%\CMake\bin"

:: Environment Paths
set "PATH=%CMAKE_FILEPATH%;%QMAKE_FILEPATH%;%PATH%"

::  Cloning TerraPrint source
::  ==========================

IF NOT EXIST %TERRAPRINT_CODEBASE_PATH% (
  mkdir %TERRAPRINT_CODEBASE_PATH% >nul 2>nul
)

cd %TERRAPRINT_CODEBASE_PATH%

git clone -b develop https://gitlab.dpi.inpe.br/terralib/terraprint.git .

echo done.
echo.

::  Setting visual studio environment
::  ==================================

echo | set /p="Configuring visual studio... "<nul

call "%VCVARS_FILEPATH%"\vcvarsall.bat x64

echo done.
echo.

::  Configuring CMake and generating files
::  =======================================

IF NOT EXIST %TERRAPRINT_BUILD_PATH% (
  mkdir %TERRAPRINT_BUILD_PATH% >nul 2>nul
)

cd /d %TERRAPRINT_BUILD_PATH% >nul 2>nul

echo | set /p="Configuring CMake... "<nul

cmake -G %_CMAKE_GENERATOR% -DCMAKE_BUILD_TYPE="Release" ^
-DCMAKE_PREFIX_PATH="%TERRALIB_DEPENDENCIES_DIR%" ^
-DCMAKE_INSTALL_PREFIX="%TERRAPRINT_INSTALL_PATH%" ^
-Dterralib_DIR="%TERRALIB_DIR%" ^
-DTERRALIB_BUILD_EXAMPLES_ENABLED:BOOL=OFF ^
-DTERRALIB_BUILD_LAYOUT_TEST_ENABLED:BOOL=OFF ^
%TERRAPRINT_CODEBASE_PATH%\build\cmake

echo done.
echo.

::  Building all Project
::  =====================

echo | set /p="Building project... "<nul

msbuild /m /t:clean ALL_BUILD.vcxproj /p:Configuration=Release

msbuild /m ALL_BUILD.vcxproj /p:Configuration=Release

echo done.
echo.

::  Installing in dependencies dir
::  ===============================

echo | set /p="Installing... "<nul

msbuild /m INSTALL.vcxproj /p:Configuration=Release

echo done.
echo.

:: ====

echo.
echo.
echo ******************************************************
echo * TerraPrint Installer for Windows 64-bits finished! *
echo ******************************************************
echo Finished!
echo.

exit /b 0
